/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Indexes;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreValue.TCoreValuePath;
import de.ship.db.tables.records.TCoreValueparamRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreValueparam extends TableImpl<TCoreValueparamRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_valueparam</code>
     */
    public static final TCoreValueparam T_CORE_VALUEPARAM = new TCoreValueparam();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreValueparamRecord> getRecordType() {
        return TCoreValueparamRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_valueparam.pk_core_valueparam</code>.
     */
    public final TableField<TCoreValueparamRecord, Integer> PK_CORE_VALUEPARAM = createField(DSL.name("pk_core_valueparam"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_valueparam.fk_valueparam_value</code>.
     */
    public final TableField<TCoreValueparamRecord, Integer> FK_VALUEPARAM_VALUE = createField(DSL.name("fk_valueparam_value"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_valueparam.param_key</code>. language
     * key of parameter key; must always be translated
     */
    public final TableField<TCoreValueparamRecord, String> PARAM_KEY = createField(DSL.name("param_key"), SQLDataType.CLOB.nullable(false), this, "language key of parameter key; must always be translated");

    /**
     * The column <code>common_dd.t_core_valueparam.param_value</code>. value of
     * param if there is one; must never be translated
     */
    public final TableField<TCoreValueparamRecord, String> PARAM_VALUE = createField(DSL.name("param_value"), SQLDataType.CLOB, this, "value of param if there is one; must never be translated");

    /**
     * The column <code>common_dd.t_core_valueparam.lastchange</code>.
     */
    public final TableField<TCoreValueparamRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    private TCoreValueparam(Name alias, Table<TCoreValueparamRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreValueparam(Name alias, Table<TCoreValueparamRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_valueparam</code> table
     * reference
     */
    public TCoreValueparam(String alias) {
        this(DSL.name(alias), T_CORE_VALUEPARAM);
    }

    /**
     * Create an aliased <code>common_dd.t_core_valueparam</code> table
     * reference
     */
    public TCoreValueparam(Name alias) {
        this(alias, T_CORE_VALUEPARAM);
    }

    /**
     * Create a <code>common_dd.t_core_valueparam</code> table reference
     */
    public TCoreValueparam() {
        this(DSL.name("t_core_valueparam"), null);
    }

    public <O extends Record> TCoreValueparam(Table<O> path, ForeignKey<O, TCoreValueparamRecord> childPath, InverseForeignKey<O, TCoreValueparamRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_VALUEPARAM);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreValueparamPath extends TCoreValueparam implements Path<TCoreValueparamRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreValueparamPath(Table<O> path, ForeignKey<O, TCoreValueparamRecord> childPath, InverseForeignKey<O, TCoreValueparamRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreValueparamPath(Name alias, Table<TCoreValueparamRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreValueparamPath as(String alias) {
            return new TCoreValueparamPath(DSL.name(alias), this);
        }

        @Override
        public TCoreValueparamPath as(Name alias) {
            return new TCoreValueparamPath(alias, this);
        }

        @Override
        public TCoreValueparamPath as(Table<?> alias) {
            return new TCoreValueparamPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.asList(Indexes.IDX_CORE_VALUEPARAM_FK_VALUEPARAM_VALUE);
    }

    @Override
    public Identity<TCoreValueparamRecord, Integer> getIdentity() {
        return (Identity<TCoreValueparamRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreValueparamRecord> getPrimaryKey() {
        return Keys.PK_CORE_VALUEPARAM;
    }

    @Override
    public List<ForeignKey<TCoreValueparamRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_VALUEPARAM__FK_VALUEPARAM_VALUE);
    }

    private transient TCoreValuePath _tCoreValue;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_value</code>
     * table.
     */
    public TCoreValuePath tCoreValue() {
        if (_tCoreValue == null)
            _tCoreValue = new TCoreValuePath(this, Keys.T_CORE_VALUEPARAM__FK_VALUEPARAM_VALUE, null);

        return _tCoreValue;
    }

    @Override
    public TCoreValueparam as(String alias) {
        return new TCoreValueparam(DSL.name(alias), this);
    }

    @Override
    public TCoreValueparam as(Name alias) {
        return new TCoreValueparam(alias, this);
    }

    @Override
    public TCoreValueparam as(Table<?> alias) {
        return new TCoreValueparam(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreValueparam rename(String name) {
        return new TCoreValueparam(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreValueparam rename(Name name) {
        return new TCoreValueparam(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreValueparam rename(Table<?> name) {
        return new TCoreValueparam(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreValueparam where(Condition condition) {
        return new TCoreValueparam(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreValueparam where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreValueparam where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreValueparam where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreValueparam where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreValueparam where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreValueparam where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreValueparam where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreValueparam whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreValueparam whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
